SystemOrganization addCategory: #Mass!

Object subclass: #MassBackEnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

!MassBackEnd methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 16:42'!
viewEdit: request

	Transcript show: (request at: #user).
	
	^ { #seems -> 'to work' } asDictionary! !

Object subclass: #MassLog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassOption
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassPlan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassServer
	instanceVariableNames: 'mBackEnd teapotInstance mode allowedRequests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 16:33'!
allowedRequests

	^ allowedRequests ifNil:[ allowedRequests := MassBackEnd selectors ].! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 16:23'!
deployment

	teapotInstance := Teapot 
		configure: { 
			#defaultOutput -> #json. 
			#port -> 8080. 
			#debugMode -> true }.

	self serveStatic.
	
	teapotInstance "this is for development ONLY for obvious reasons"
		POST: '/api/<expression>' -> [ :req | self deploymentResponse: req ].! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 16:38'!
deploymentResponse: req

	^ [self sanitize: req. mBackEnd perform: (req at: #expression) asSymbol with: req] 
				on: Error 
				do: [ :ex | ex description ].
		"it expects expressions that return compatible values for JSON encoding"
			! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 16:18'!
development

	teapotInstance := Teapot 
		configure: { 
			#defaultOutput -> #json. 
			#port -> 8080. 
			#debugMode -> true }.
			
	self serveStatic.
	
	teapotInstance "this is for development ONLY for obvious reasons"
		POST: '/api/<expression>' -> [ :req | self developmentResponse: req ].
			! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 16:37'!
developmentResponse: req

	^ [self sanitize: req. mBackEnd perform: (req at: #expression) asSymbol with: req] 
				on: Error 
				do: [ :ex | ex description ].
		"it expects expressions that return compatible values for JSON encoding"
			! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 18:01'!
forDeployment

	mode := #deployment.

	"teapotInstance := Teapot 
		configure: { 
			#defaultOutput -> #json. 
			#port -> 8080 }.	"! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 18:01'!
forDevelopment

	mode := #development! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 17:12'!
initialize

	mBackEnd := MassBackEnd new.
	! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 16:39'!
sanitize: req

	(self allowedRequests includes: (req at: #expression))
		ifFalse: [ Error signal: 'Not a valid Request' ]
	! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 14:06'!
serveStatic

	teapotInstance 
		serveStatic: '/' 
		from: (SmalltalkImage current 
					imageDirectory parent parent 
					parent asFileReference pathString , '/static').
	! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 18:01'!
start

	self perform: mode.
	teapotInstance start.
	! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 17:38'!
stop

	teapotInstance start
	! !

Object subclass: #MassSimulation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!
